<template>
    <div>
    
        <v-container>
    
            <v-card width="100%" class="mb-2">
    
                <v-card-text>
    
                    <v-row>
    
    
    
                        <v-col xs="4" md="4">
    
                            <h4 class="text-center mb-1">Recherche</h4>
    
                            <v-text-field v-model="searchWord" label="Rechercher"></v-text-field>
    
                        </v-col>
    
    
    
                        <v-col xs="4" md="4">
    
                            <h4 class="text-center mb-1">Categorie</h4>
    
                            <v-sheet class="mx-auto" max-width="450" elevation="0">
    
                                <v-select :items="allCategorieMateriel" v-model="searchCat" item-text="nom"></v-select>
    
                            </v-sheet>
    
                        </v-col>
    
                        <v-col xs="4" md="4" align="center" align-self="center">
    
                            <v-btn color="error" @click="resetAll">
    
                                Annuler
    
                            </v-btn>
    
                        </v-col>
    
                    </v-row>
    
                </v-card-text>
    
            </v-card>
    
            <v-row>
    
                <v-col sm="4" xs="12" v-for="materiel in pagination.data" :key="materiel._id">
    
                    <v-hover v-slot="{ hover }">
    
                        <v-card class="mx-auto" color="grey lighten-4">
    
                            <v-img :aspect-ratio="16/9" :src="$config.DEFAULT_URL +'materiel/'+ materiel.images[0]">
    
                                <v-expand-transition>
    
                                    <div v-if="hover" class="d-flex transition-fast-in-fast-out primary darken-2 v-card--reveal display-3 white--text" style="height: 100%;">
    
                                        {{ materiel.prix }} FCFA
    
                                    </div>
    
                                </v-expand-transition>
    
                            </v-img>
    
                            <v-card-text class="pt-6" style="position: relative;">
    
                                <v-btn absolute color="primary" class="white--text" fab large right top>
    
                                    <v-icon>mdi-phone</v-icon>
    
                                </v-btn>
    
                                <div class="font-weight-light grey--text title mb-2">
    
                                    {{ materiel.nom}}
    
                                </div>
    
                                <h3 class=" font-weight-light primary--text mb-2">
    
                                    {{ materiel.contactun}}
    
                                </h3>
    
                            </v-card-text>
    
                        </v-card>
    
                    </v-hover>
    
                </v-col>
    
            </v-row>
    
        </v-container>
    
        <v-container>
    
            <div class="text-center">
    
                <v-pagination v-model="page" :length="pagination.total_pages"></v-pagination>
    
            </div>
    
        </v-container>
    
    </div>
</template>
<script>
export default {
    name: "boutiques",
    data: () => ({
        pagination: {},
        page: 1,
        allCategorieMateriel: [],
        searchWord: "",
        searchCat: "",

    }),

    created() {

        this.getCategorieMateriel();
        this.getMateriel();
    },

    methods: {


        async getCategorieMateriel() {
            try {
                await this.$store.dispatch('autoshop/loadCategorieMateriel')
                this.allCategorieMateriel = this.$store.getters["autoshop/categorieMateriels"];
            } catch (e) {
                console.log(e);
            }
        },

        rechercheMateriel() {


            var allMat = this.$store.getters["autoshop/materiels"];

            const result = allMat.filter((mat) => {

                if (this.searchCat.length > 0) {
                    return (mat.nom.toLowerCase().includes(this.searchWord.toLowerCase()) && mat.type_materiel === this.searchCat)
                } else {
                    return (mat.nom.toLowerCase().includes(this.searchWord.toLowerCase()))

                }



            });


            this.pagination = this.$config.paginator(result);


        },

        async getMateriel() {

            try {

                await this.$store.dispatch('autoshop/loadMateriels');
                var allMateriel = this.$store.getters["autoshop/materiels"];
                this.pagination = this.$config.paginator(allMateriel);

            } catch (error) {
                console.log(error);
            }

        },

        resetAll() {

            this.searchWord = "";
            this.searchCat = "";

        }

    },


    watch: {

        searchWord() {

            this.rechercheMateriel();
        },

        searchCat() {
            this.rechercheMateriel();
        },
        page(value) {
            var allMateriel = this.$store.getters["autoshop/materiels"];
            this.pagination = this.$config.paginator(allMateriel, value);
        }

    }
}
</script>
<style scoped>
.v-card--reveal {
    align-items: center;
    bottom: 0;
    justify-content: center;
    opacity: .5;
    position: absolute;
    width: 100%;
}
</style>